"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const config_1 = require("@schematics/angular/utility/config");
const project_1 = require("@schematics/angular/utility/project");
const parse_name_1 = require("@schematics/angular/utility/parse-name");
const schematics_1 = require("@angular-devkit/schematics");
const core_1 = require("@angular-devkit/core");
function setupOptions(host, options) {
    const workspace = config_1.getWorkspace(host);
    if (!options.project) {
        options.project = Object.keys(workspace.projects)[0];
    }
    const project = workspace.projects[options.project];
    if (options.path === undefined) {
        options.path = project_1.buildDefaultPath(project);
    }
    const parsedPath = parse_name_1.parseName(options.path, options.name);
    options.name = parsedPath.name;
    options.path = parsedPath.path;
    return host;
}
exports.setupOptions = setupOptions;
// You don't have to export the function as default. You can also have more than one rule factory
// per file.
function firebaseCloudFunction(options) {
    return (tree, _context) => {
        setupOptions(tree, options);
        const movePath = (options.flat) ?
            core_1.normalize(options.path) :
            core_1.normalize(options.path + '/' + core_1.strings.dasherize(options.name));
        const templateSource = schematics_1.apply(schematics_1.url('./files'), [
            options.spec ? schematics_1.noop() : schematics_1.filter(path => !path.endsWith('.spec.ts')),
            schematics_1.template(Object.assign({}, core_1.strings, options)),
            schematics_1.move(movePath),
        ]);
        const rule = schematics_1.mergeWith(templateSource, schematics_1.MergeStrategy.Default);
        return rule(tree, _context);
    };
}
exports.firebaseCloudFunction = firebaseCloudFunction;
//# sourceMappingURL=index.js.map